---
title: WaveShaperNode.curve
slug: Web/API/WaveShaperNode/curve
tags:
  - API
  - Property
  - Reference
  - WaveShaperNode
  - Web Audio API
  - curve
---
<p>{{ APIRef("Web Audio API") }}</p>

<p>The <code>curve</code> property of the {{ domxref("WaveShaperNode") }} interface is a {{domxref("Float32Array")}} of numbers describing the distortion to apply.</p>

<p>The mid-element of the array is applied to any signal value of <code>0</code>, the first one to signal values of <code>-1</code>, and the last to signal values of <code>1</code>; values lower than <code>-1</code> or greater than <code>1</code> are treated like <code>-1</code> or <code>1</code> respectively.</p>

<p>If necessary, intermediate values of the distortion curve are linearly interpolated.</p>

<div class="note">
<p><strong>Note</strong>: The array can be a <code>null</code> value: in that case, no distortion is applied to the input signal.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">var audioCtx = new AudioContext();
var distortion = audioCtx.createWaveShaper();
distortion.curve = myCurveDataArray; // myCurveDataArray is a Float32Array
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("Float32Array")}}.</p>

<h2 id="Example">Example</h2>

<p>{{page("/en-US/docs/Web/API/AudioContext.createWaveShaper","Example")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-waveshapernode-curve', 'curve')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.WaveShaperNode.curve")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
